﻿using System.Windows.Controls;
using Infragistics.Controls.Grids;
using System;

namespace TestApp
{
    public partial class MainPage : UserControl
    {
        private TestViewModel _viewModel;

        public MainPage()
        {
            this.InitializeComponent();
            this._viewModel = new TestViewModel();
            this.DataContext = this._viewModel;
        }

        private void XGrid_CellExitedEditMode(object sender, CellExitedEditingEventArgs e)
        {
            if (e.Cell != null && e.Cell.Column != null && e.Cell.Row != null)
            {
                string key = e.Cell.Column.Key;
                UnboundColumn unboundColumn = this.XGrid.Columns.AllColumns["IntPlusDouble"] as UnboundColumn;

                if (unboundColumn != null &&
                    (string.Compare(key, "Int", StringComparison.InvariantCultureIgnoreCase) == 0 || 
                    string.Compare(key, "Double", StringComparison.InvariantCultureIgnoreCase) == 0))
                {
                    e.Cell.Row.Cells[unboundColumn].Refresh();
                    e.Cell.Row.Manager.RefreshSummaries();
                }
            }
        }
    }
}
