﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics;
using System.Linq;

namespace TestApp
{
    public class MyCustomSumOperand : SummaryOperandBase
    {
        MySumSummaryCalculator _calc;

        protected override string DefaultRowDisplayLabel
        {
            get { return "My SUM"; }
        }

        protected override string DefaultSelectionDisplayLabel
        {
            get { return "My SUM"; }
        }

        public override SummaryCalculatorBase SummaryCalculator
        {
            get
            {
                if (this._calc == null)
                {
                    this._calc = new MySumSummaryCalculator();
                }

                return this._calc;
            }
        }
    }

    public class MySumSummaryCalculator : SynchronousSummaryCalculator
    {
        public override object Summarize(IQueryable data, string fieldKey)
        {
            var resolvedData = data.Cast<TData>();

            double sum = 0;

            foreach (var item in resolvedData)
            {
                sum += item.Int + item.Double;
            }

            return sum;
        }

    }
}
